
#include <stdio.h>

#define		MAX						5	//	 ũ
#define		UNDER_CONSTRUCTION		-1	//	  ǥ

static int g_Map[MAX][MAX] =
{
	0, 1, 1, 1, UNDER_CONSTRUCTION,
	1, 0, 0, 0, 0,
	1, 0, 0, 0, 0,
	1, UNDER_CONSTRUCTION, 0, 0, 0,
	1, 0, 0, 0, 0
};

static int g_DT[MAX][MAX];	//	 ̺

/*
	(0,0)  ϴ(MAX - 1, MAX - 1) ϴ
	    ϴ Լ
*/
int SearchWay(void);

/*
	ش   ̵ üũϴ Լ
	1 ϸ ̵ϰ 0 ϸ ̵Ұ ̴.
*/
int MoveableMap(int row, int col);

//	 ̺  ִ Լ
void DisplayDT(void);

int main(void)
{
	int wayCnt = SearchWay();

	printf(" : %d\n", wayCnt);

	DisplayDT();

	return 0;
}

/*
	(0,0)  ϴ(MAX - 1, MAX - 1) ϴ
	    ϴ Լ
*/
int SearchWay(void)
{
	int row, col;

	//	   ̺ 
	for (row = 0; row < MAX; row++)
	{
		for (col = 0; col < MAX; col++)
			g_DT[row][col] = g_Map[row][col];
	}

	for (row = 1; row < MAX; row++)
	{
		for (col = 1; col < MAX; col++)
		{
			if (g_DT[row][col] == UNDER_CONSTRUCTION)
				continue;

			//	 row col ߽ ʰ   ̵  (  ƴ )
			if (MoveableMap(row - 1, col) && MoveableMap(row, col - 1))
			{
				//	 row col         Ѵ. 
				g_DT[row][col] = g_DT[row - 1][col] + g_DT[row][col - 1];
			}

			//	 row col ߽  ̵ Ұ (  )
			else if (!MoveableMap(row - 1, col))
			{
				//	 row col     ̴. (  )
				g_DT[row][col] = g_DT[row][col - 1];
			}

			//	 row col ߽  ̵ Ұ (  )
			else if (!MoveableMap(row, col - 1))
			{
				//	 row col     ̴. (  )
				g_DT[row][col] = g_DT[row - 1][col];
			}
		}
	}
	return g_DT[MAX - 1][MAX - 1];
}

/*
	ش   ̵ üũϴ Լ
	1 ϸ ̵ϰ 0 ϸ ̵Ұ ̴.
*/
int MoveableMap(int row, int col)
{
	if (g_DT[row][col] != UNDER_CONSTRUCTION)
		return 1;
	else
		return 0;
}

//	 ̺  ִ Լ
void DisplayDT(void)
{
	int row, col;

	for (row = 0; row < MAX; row++)
	{
		for (col = 0; col < MAX; col++)
			printf("%2d ", g_DT[row][col]);

		printf("\n");
	}
	printf("\n");
}